processing.opengl

## Class PGL

- Object
- - PGL

- Direct Known Subclasses:
    PJOGL

      public abstract class PGL
      extends Object

  Processing-OpenGL abstraction layer. Needs to be implemented by subclasses using specific OpenGL-Java bindings. It includes a full GLES 2.0 interface.

- - ### Field Summary

    Fields
    Modifier and Type | Field and Description
    --- | ---
    `static int` | `ALIASED_LINE_WIDTH_RANGE`
    `static int` | `ALIASED_POINT_SIZE_RANGE`
    `static int` | `ALPHA`
    `static int` | `ALPHA8`
    `static int` | `ALWAYS`
    `static int` | `ARRAY_BUFFER`
    `static int` | `BACK`
    `static int` | `BLEND`
    `static int` | `BOOL`
    `static int` | `BOOL_VEC2`
    `static int` | `BOOL_VEC3`
    `static int` | `BOOL_VEC4`
    `static int` | `BUFFER_SIZE`
    `static int` | `BUFFER_USAGE`
    `static int` | `BYTE`
    `static int` | `CCW`
    `static int` | `CLAMP_TO_EDGE`
    `static int` | `COLOR_ATTACHMENT0`
    `static int` | `COLOR_ATTACHMENT1`
    `static int` | `COLOR_ATTACHMENT2`
    `static int` | `COLOR_ATTACHMENT3`
    `static int` | `COLOR_BUFFER_BIT`
    `static int` | `COMPILE_STATUS`
    `static int` | `COMPRESSED_TEXTURE_FORMATS`
    `static int` | `CONSTANT_ALPHA`
    `static int` | `CONSTANT_COLOR`
    `static int` | `CULL_FACE`
    `static int` | `CURRENT_VERTEX_ATTRIB`
    `static int` | `CW`
    `static int` | `DECR`
    `static int` | `DECR_WRAP`
    `static int` | `DELETE_STATUS`
    `static int` | `DEPTH_ATTACHMENT`
    `static int` | `DEPTH_BITS`
    `static int` | `DEPTH_BUFFER_BIT`
    `static int` | `DEPTH_COMPONENT`
    `static int` | `DEPTH_COMPONENT16`
    `static int` | `DEPTH_COMPONENT24`
    `static int` | `DEPTH_COMPONENT32`
    `static int` | `DEPTH_STENCIL`
    `static int` | `DEPTH_TEST`
    `static int` | `DEPTH_WRITEMASK`
    `static int` | `DEPTH24_STENCIL8`
    `static int` | `DITHER`
    `static int` | `DONT_CARE`
    `static int` | `DRAW_FRAMEBUFFER`
    `static int` | `DST_ALPHA`
    `static int` | `DST_COLOR`
    `static int` | `DYNAMIC_DRAW`
    `static int` | `ELEMENT_ARRAY_BUFFER`
    `static int` | `EQUAL`
    `static int` | `EXTENSIONS`
    `static int` | `FALSE`
    `static int` | `FASTEST`
    `static int` | `FLOAT`
    `static int` | `FLOAT_MAT2`
    `static int` | `FLOAT_MAT3`
    `static int` | `FLOAT_MAT4`
    `static int` | `FLOAT_VEC2`
    `static int` | `FLOAT_VEC3`
    `static int` | `FLOAT_VEC4`
    `static int` | `FRAGMENT_SHADER`
    `static int` | `FRAMEBUFFER`
    `static int` | `FRAMEBUFFER_ATTACHMENT_OBJECT_NAME`
    `static int` | `FRAMEBUFFER_ATTACHMENT_OBJECT_TYPE`
    `static int` | `FRAMEBUFFER_ATTACHMENT_TEXTURE_CUBE_MAP_FACE`
    `static int` | `FRAMEBUFFER_ATTACHMENT_TEXTURE_LEVEL`
    `static int` | `FRAMEBUFFER_COMPLETE`
    `static String` | `FRAMEBUFFER_ERROR`
    `static int` | `FRAMEBUFFER_INCOMPLETE_ATTACHMENT`
    `static int` | `FRAMEBUFFER_INCOMPLETE_DIMENSIONS`
    `static int` | `FRAMEBUFFER_INCOMPLETE_DRAW_BUFFER`
    `static int` | `FRAMEBUFFER_INCOMPLETE_FORMATS`
    `static int` | `FRAMEBUFFER_INCOMPLETE_MISSING_ATTACHMENT`
    `static int` | `FRAMEBUFFER_INCOMPLETE_READ_BUFFER`
    `static int` | `FRAMEBUFFER_UNSUPPORTED`
    `static int` | `FRONT`
    `static int` | `FRONT_AND_BACK`
    `static int` | `FUNC_ADD`
    `static int` | `FUNC_MAX`
    `static int` | `FUNC_MIN`
    `static int` | `FUNC_REVERSE_SUBTRACT`
    `static int` | `FUNC_SUBTRACT`
    `static int` | `GENERATE_MIPMAP_HINT`
    `static int` | `GEQUAL`
    `static int` | `GREATER`
    `static int` | `HIGH_FLOAT`
    `static int` | `HIGH_INT`
    `static int` | `INCR`
    `static int` | `INCR_WRAP`
    `static int` | `INFO_LOG_LENGTH`
    `static int` | `INT`
    `static int` | `INT_VEC2`
    `static int` | `INT_VEC3`
    `static int` | `INT_VEC4`
    `static int` | `INVERT`
    `static int` | `KEEP`
    `static int` | `LEQUAL`
    `static int` | `LESS`
    `static int` | `LINE_LOOP`
    `static int` | `LINE_SMOOTH`
    `static int` | `LINE_STRIP`
    `static int` | `LINEAR`
    `static int` | `LINEAR_MIPMAP_LINEAR`
    `static int` | `LINEAR_MIPMAP_NEAREST`
    `static int` | `LINES`
    `static int` | `LINK_STATUS`
    `static int` | `LOW_FLOAT`
    `static int` | `LOW_INT`
    `static int` | `LUMINANCE`
    `static int` | `LUMINANCE_ALPHA`
    `static int` | `MAX_COMBINED_TEXTURE_IMAGE_UNITS`
    `static int` | `MAX_SAMPLES`
    `static int` | `MAX_TEXTURE_IMAGE_UNITS`
    `static int` | `MAX_TEXTURE_MAX_ANISOTROPY`
    `static int` | `MAX_TEXTURE_SIZE`
    `static int` | `MAX_VERTEX_ATTRIBS`
    `static int` | `MAX_VERTEX_TEXTURE_IMAGE_UNITS`
    `static int` | `MEDIUM_FLOAT`
    `static int` | `MEDIUM_INT`
    `static String` | `MISSING_FBO_ERROR`
    `static String` | `MISSING_GLFUNC_ERROR`
    `static String` | `MISSING_GLSL_ERROR`
    `static int` | `MULTISAMPLE`
    `static int` | `NEAREST`
    `static int` | `NEVER`
    `static int` | `NICEST`
    `static String` | `NONPRIMARY_ERROR`
    `static int` | `NOTEQUAL`
    `static int` | `NUM_COMPRESSED_TEXTURE_FORMATS`
    `static int` | `ONE`
    `static int` | `ONE_MINUS_CONSTANT_ALPHA`
    `static int` | `ONE_MINUS_CONSTANT_COLOR`
    `static int` | `ONE_MINUS_DST_COLOR`
    `static int` | `ONE_MINUS_SRC_ALPHA`
    `static int` | `ONE_MINUS_SRC_COLOR`
    `static int` | `PACK_ALIGNMENT`
    `static int` | `POINTS`
    `static int` | `POLYGON_OFFSET_FILL`
    `static int` | `POLYGON_SMOOTH`
    `float` | `presentX`
    `float` | `presentY`
    `boolean` | `primaryPGL` true if this is the GL interface for a primary surface PGraphics
    `static int` | `READ_FRAMEBUFFER`
    `static int` | `READ_ONLY`
    `static int` | `READ_WRITE`
    `static int` | `RENDERBUFFER`
    `static int` | `RENDERBUFFER_ALPHA_SIZE`
    `static int` | `RENDERBUFFER_BLUE_SIZE`
    `static int` | `RENDERBUFFER_DEPTH_SIZE`
    `static int` | `RENDERBUFFER_GREEN_SIZE`
    `static int` | `RENDERBUFFER_HEIGHT`
    `static int` | `RENDERBUFFER_INTERNAL_FORMAT`
    `static int` | `RENDERBUFFER_RED_SIZE`
    `static int` | `RENDERBUFFER_STENCIL_SIZE`
    `static int` | `RENDERBUFFER_WIDTH`
    `static int` | `RENDERER`
    `static int` | `REPEAT`
    `static int` | `REPLACE`
    `int` | `reqNumSamples`
    `static int` | `REQUESTED_ALPHA_BITS`
    `static int` | `REQUESTED_DEPTH_BITS`
    `static int` | `REQUESTED_STENCIL_BITS`
    `static int` | `RGB`
    `static int` | `RGB5_A1`
    `static int` | `RGB565`
    `static int` | `RGB8`
    `static int` | `RGBA`
    `static int` | `RGBA4`
    `static int` | `RGBA8`
    `static int` | `SAMPLE_ALPHA_TO_COVERAGE`
    `static int` | `SAMPLE_COVERAGE`
    `static int` | `SAMPLER_2D`
    `static int` | `SAMPLER_CUBE`
    `static int` | `SAMPLES`
    `static int` | `SCISSOR_TEST`
    `static int` | `SHADER_SOURCE_LENGTH`
    `static int` | `SHADER_TYPE`
    `static int` | `SHADING_LANGUAGE_VERSION`
    `static int` | `SHORT`
    `static int` | `SRC_ALPHA`
    `static int` | `SRC_ALPHA_SATURATE`
    `static int` | `SRC_COLOR`
    `static int` | `STATIC_DRAW`
    `static int` | `STENCIL_ATTACHMENT`
    `static int` | `STENCIL_BITS`
    `static int` | `STENCIL_BUFFER_BIT`
    `static int` | `STENCIL_INDEX`
    `static int` | `STENCIL_INDEX1`
    `static int` | `STENCIL_INDEX4`
    `static int` | `STENCIL_INDEX8`
    `static int` | `STENCIL_TEST`
    `static int` | `STREAM_DRAW`
    `static int` | `TESS_WINDING_NONZERO`
    `static int` | `TESS_WINDING_ODD`
    `static int` | `TEXTURE_2D`
    `static int` | `TEXTURE_BINDING_2D`
    `static int` | `TEXTURE_BINDING_RECTANGLE`
    `static int` | `TEXTURE_CUBE_MAP`
    `static int` | `TEXTURE_CUBE_MAP_NEGATIVE_X`
    `static int` | `TEXTURE_CUBE_MAP_NEGATIVE_Y`
    `static int` | `TEXTURE_CUBE_MAP_NEGATIVE_Z`
    `static int` | `TEXTURE_CUBE_MAP_POSITIVE_X`
    `static int` | `TEXTURE_CUBE_MAP_POSITIVE_Y`
    `static int` | `TEXTURE_CUBE_MAP_POSITIVE_Z`
    `static int` | `TEXTURE_MAG_FILTER`
    `static int` | `TEXTURE_MAX_ANISOTROPY`
    `static int` | `TEXTURE_MIN_FILTER`
    `static int` | `TEXTURE_RECTANGLE`
    `static int` | `TEXTURE_WRAP_R`
    `static int` | `TEXTURE_WRAP_S`
    `static int` | `TEXTURE_WRAP_T`
    `static int` | `TEXTURE0`
    `static int` | `TEXTURE1`
    `static int` | `TEXTURE2`
    `static int` | `TEXTURE3`
    `static String` | `TEXUNIT_ERROR`
    `static int` | `TRIANGLE_FAN`
    `static int` | `TRIANGLE_STRIP`
    `static int` | `TRIANGLES`
    `static int` | `TRUE`
    `static int` | `UNPACK_ALIGNMENT`
    `static int` | `UNSIGNED_BYTE`
    `static int` | `UNSIGNED_INT`
    `static int` | `UNSIGNED_SHORT`
    `static int` | `UNSIGNED_SHORT_4_4_4_4`
    `static int` | `UNSIGNED_SHORT_5_5_5_1`
    `static int` | `UNSIGNED_SHORT_5_6_5`
    `static String` | `UNSUPPORTED_GLPROF_ERROR`
    `static int` | `VALIDATE_STATUS`
    `static int` | `VENDOR`
    `static int` | `VERSION`
    `static int` | `VERTEX_ATTRIB_ARRAY_BUFFER_BINDING`
    `static int` | `VERTEX_ATTRIB_ARRAY_ENABLED`
    `static int` | `VERTEX_ATTRIB_ARRAY_NORMALIZED`
    `static int` | `VERTEX_ATTRIB_ARRAY_POINTER`
    `static int` | `VERTEX_ATTRIB_ARRAY_SIZE`
    `static int` | `VERTEX_ATTRIB_ARRAY_STRIDE`
    `static int` | `VERTEX_ATTRIB_ARRAY_TYPE`
    `static int` | `VERTEX_SHADER`
    `static int` | `VIEWPORT`
    `static String` | `WIKI`
    `static int` | `WRITE_ONLY`
    `static int` | `ZERO`

  - ### Constructor Summary

    Constructors
    Constructor and Description
    `PGL()`
    `PGL(PGraphicsOpenGL pg)`

  - ### Method Summary

    All Methods Static Methods Instance Methods Abstract Methods Concrete Methods Deprecated Methods
    Modifier and Type | Method and Description
    --- | ---
    `void` | `activeTexture(int texture)`
    `abstract void` | `attachShader(int program, int shader)`
    `abstract void` | `bindAttribLocation(int program, int index, String name)`
    `abstract void` | `bindBuffer(int target, int buffer)`
    `void` | `bindFramebuffer(int target, int framebuffer)`
    `abstract void` | `bindRenderbuffer(int target, int renderbuffer)`
    `void` | `bindTexture(int target, int texture)`
    `abstract void` | `blendColor(float red, float green, float blue, float alpha)`
    `abstract void` | `blendEquation(int mode)`
    `abstract void` | `blendEquationSeparate(int modeRGB, int modeAlpha)`
    `abstract void` | `blendFunc(int src, int dst)`
    `abstract void` | `blendFuncSeparate(int srcRGB, int dstRGB, int srcAlpha, int dstAlpha)`
    `abstract void` | `blitFramebuffer(int srcX0, int srcY0, int srcX1, int srcY1, int dstX0, int dstY0, int dstX1, int dstY1, int mask, int filter)`
    `abstract void` | `bufferData(int target, int size, Buffer data, int usage)`
    `abstract void` | `bufferSubData(int target, int offset, int size, Buffer data)`
    `abstract int` | `checkFramebufferStatus(int target)`
    `abstract void` | `clear(int buf)`
    `abstract void` | `clearColor(float r, float g, float b, float a)`
    `abstract void` | `clearDepth(float d)`
    `abstract void` | `clearStencil(int s)`
    `abstract void` | `colorMask(boolean r, boolean g, boolean b, boolean a)`
    `abstract void` | `compileShader(int shader)`
    `abstract void` | `compressedTexImage2D(int target, int level, int internalFormat, int width, int height, int border, int imageSize, Buffer data)`
    `abstract void` | `compressedTexSubImage2D(int target, int level, int xOffset, int yOffset, int width, int height, int format, int imageSize, Buffer data)`
    `abstract void` | `copyTexImage2D(int target, int level, int internalFormat, int x, int y, int width, int height, int border)`
    `abstract void` | `copyTexSubImage2D(int target, int level, int xOffset, int yOffset, int x, int y, int width, int height)`
    `abstract int` | `createProgram()`
    `abstract int` | `createShader(int type)`
    `abstract void` | `cullFace(int mode)`
    `abstract void` | `deleteBuffers(int n, IntBuffer buffers)`
    `abstract void` | `deleteFramebuffers(int n, IntBuffer framebuffers)`
    `abstract void` | `deleteProgram(int program)`
    `abstract void` | `deleteRenderbuffers(int n, IntBuffer renderbuffers)`
    `abstract void` | `deleteShader(int shader)`
    `abstract void` | `deleteTextures(int n, IntBuffer textures)`
    `abstract void` | `depthFunc(int func)`
    `abstract void` | `depthMask(boolean mask)`
    `abstract void` | `depthRangef(float n, float f)`
    `abstract void` | `detachShader(int program, int shader)`
    `abstract void` | `disable(int value)`
    `void` | `disableFBOLayer()`
    `abstract void` | `disableVertexAttribArray(int index)`
    `void` | `dispose()`
    `void` | `drawArrays(int mode, int first, int count)`
    `abstract void` | `drawArraysImpl(int mode, int first, int count)`
    `abstract void` | `drawBuffer(int buf)`
    `void` | `drawElements(int mode, int count, int type, int offset)`
    `abstract void` | `drawElementsImpl(int mode, int count, int type, int offset)`
    `void` | `drawTexture(int target, int id, int width, int height, int X0, int Y0, int X1, int Y1)` Not an approved function, this will change or be removed in the future.
    `void` | `drawTexture(int target, int id, int texW, int texH, int viewX, int viewY, int viewW, int viewH, int texX0, int texY0, int texX1, int texY1, int scrX0, int scrY0, int scrX1, int scrY1)` Not an approved function, this will change or be removed in the future.
    `void` | `drawTexture(int target, int id, int texW, int texH, int viewX, int viewY, int viewW, int viewH, int viewF, int texX0, int texY0, int texX1, int texY1, int scrX0, int scrY0, int scrX1, int scrY1)`
    `abstract void` | `enable(int value)`
    `void` | `enableFBOLayer()`
    `abstract void` | `enableVertexAttribArray(int index)`
    `abstract String` | `errorString(int err)`
    `abstract void` | `finish()`
    `abstract void` | `flush()`
    `abstract void` | `framebufferRenderbuffer(int target, int attachment, int rendbuferfTarget, int renderbuffer)`
    `abstract void` | `framebufferTexture2D(int target, int attachment, int texTarget, int texture, int level)`
    `abstract void` | `frontFace(int dir)`
    `abstract void` | `genBuffers(int n, IntBuffer buffers)`
    `abstract void` | `generateMipmap(int target)`
    `abstract void` | `genFramebuffers(int n, IntBuffer framebuffers)`
    `abstract void` | `genRenderbuffers(int n, IntBuffer renderbuffers)`
    `abstract void` | `genTextures(int n, IntBuffer textures)`
    `abstract String` | `getActiveAttrib(int program, int index, IntBuffer size, IntBuffer type)`
    `abstract String` | `getActiveUniform(int program, int index, IntBuffer size, IntBuffer type)`
    `abstract void` | `getAttachedShaders(int program, int maxCount, IntBuffer count, IntBuffer shaders)`
    `abstract int` | `getAttribLocation(int program, String name)`
    `abstract void` | `getBooleanv(int value, IntBuffer data)`
    `abstract void` | `getBufferParameteriv(int target, int value, IntBuffer data)`
    `abstract int` | `getError()`
    `abstract void` | `getFloatv(int value, FloatBuffer data)`
    `abstract void` | `getFramebufferAttachmentParameteriv(int target, int attachment, int pname, IntBuffer params)`
    `abstract void` | `getIntegerv(int value, IntBuffer data)`
    `abstract Object` | `getNative()`
    `abstract String` | `getProgramInfoLog(int program)`
    `abstract void` | `getProgramiv(int program, int pname, IntBuffer params)`
    `abstract void` | `getRenderbufferParameteriv(int target, int pname, IntBuffer params)`
    `abstract String` | `getShaderInfoLog(int shader)`
    `abstract void` | `getShaderiv(int shader, int pname, IntBuffer params)`
    `abstract void` | `getShaderPrecisionFormat(int shaderType, int precisionType, IntBuffer range, IntBuffer precision)`
    `abstract String` | `getShaderSource(int shader)`
    `abstract String` | `getString(int name)`
    `abstract void` | `getTexParameterfv(int target, int pname, FloatBuffer params)`
    `abstract void` | `getTexParameteriv(int target, int pname, IntBuffer params)`
    `abstract void` | `getUniformfv(int program, int location, FloatBuffer params)`
    `abstract void` | `getUniformiv(int program, int location, IntBuffer params)`
    `abstract int` | `getUniformLocation(int program, String name)`
    `abstract void` | `getVertexAttribfv(int index, int pname, FloatBuffer params)`
    `abstract void` | `getVertexAttribiv(int index, int pname, IntBuffer params)`
    `abstract void` | `getVertexAttribPointerv(int index, int pname, ByteBuffer data)`
    `abstract void` | `hint(int target, int hint)`
    `void` | `initPresentMode(float x, float y)`
    `boolean` | `insideCloseButton(float x, float y)`
    `abstract void` | `isBuffer(int buffer)`
    `abstract boolean` | `isEnabled(int value)`
    `abstract boolean` | `isFramebuffer(int framebuffer)`
    `abstract boolean` | `isProgram(int program)`
    `abstract boolean` | `isRenderbuffer(int renderbuffer)`
    `abstract boolean` | `isShader(int shader)`
    `abstract boolean` | `isTexture(int texture)`
    `abstract void` | `lineWidth(float width)`
    `abstract void` | `linkProgram(int program)`
    `abstract ByteBuffer` | `mapBuffer(int target, int access)`
    `abstract ByteBuffer` | `mapBufferRange(int target, int offset, int length, int access)`
    `abstract void` | `pixelStorei(int pname, int param)`
    `abstract void` | `polygonOffset(float factor, float units)`
    `boolean` | `presentMode()`
    `float` | `presentX()`
    `float` | `presentY()`
    `abstract void` | `readBuffer(int buf)`
    `void` | `readPixels(int x, int y, int width, int height, int format, int type, Buffer buffer)`
    `abstract void` | `releaseShaderCompiler()`
    `abstract void` | `renderbufferStorage(int target, int internalFormat, int width, int height)`
    `abstract void` | `renderbufferStorageMultisample(int target, int samples, int format, int width, int height)`
    `void` | `requestFBOLayer()` Deprecated.
    `void` | `resetFBOLayer()`
    `abstract void` | `sampleCoverage(float value, boolean invert)`
    `abstract void` | `scissor(int x, int y, int w, int h)`
    `void` | `setPrimary(boolean primary)`
    `void` | `setThread(Thread thread)`
    `abstract void` | `shaderBinary(int count, IntBuffer shaders, int binaryFormat, Buffer binary, int length)`
    `abstract void` | `shaderSource(int shader, String source)`
    `static int` | `smoothToSamples(int smooth)`
    `abstract void` | `stencilFunc(int func, int ref, int mask)`
    `abstract void` | `stencilFuncSeparate(int face, int func, int ref, int mask)`
    `abstract void` | `stencilMask(int mask)`
    `abstract void` | `stencilMaskSeparate(int face, int mask)`
    `abstract void` | `stencilOp(int sfail, int dpfail, int dppass)`
    `abstract void` | `stencilOpSeparate(int face, int sfail, int dpfail, int dppass)`
    `abstract void` | `texImage2D(int target, int level, int internalFormat, int width, int height, int border, int format, int type, Buffer data)`
    `abstract void` | `texParameterf(int target, int pname, float param)`
    `abstract void` | `texParameterfv(int target, int pname, FloatBuffer params)`
    `abstract void` | `texParameteri(int target, int pname, int param)`
    `abstract void` | `texParameteriv(int target, int pname, IntBuffer params)`
    `abstract void` | `texSubImage2D(int target, int level, int xOffset, int yOffset, int width, int height, int format, int type, Buffer data)`
    `boolean` | `threadIsCurrent()`
    `abstract void` | `uniform1f(int location, float value)`
    `abstract void` | `uniform1fv(int location, int count, FloatBuffer v)`
    `abstract void` | `uniform1i(int location, int value)`
    `abstract void` | `uniform1iv(int location, int count, IntBuffer v)`
    `abstract void` | `uniform2f(int location, float value0, float value1)`
    `abstract void` | `uniform2fv(int location, int count, FloatBuffer v)`
    `abstract void` | `uniform2i(int location, int value0, int value1)`
    `abstract void` | `uniform2iv(int location, int count, IntBuffer v)`
    `abstract void` | `uniform3f(int location, float value0, float value1, float value2)`
    `abstract void` | `uniform3fv(int location, int count, FloatBuffer v)`
    `abstract void` | `uniform3i(int location, int value0, int value1, int value2)`
    `abstract void` | `uniform3iv(int location, int count, IntBuffer v)`
    `abstract void` | `uniform4f(int location, float value0, float value1, float value2, float value3)`
    `abstract void` | `uniform4fv(int location, int count, FloatBuffer v)`
    `abstract void` | `uniform4i(int location, int value0, int value1, int value2, int value3)`
    `abstract void` | `uniform4iv(int location, int count, IntBuffer v)`
    `abstract void` | `uniformMatrix2fv(int location, int count, boolean transpose, FloatBuffer mat)`
    `abstract void` | `uniformMatrix3fv(int location, int count, boolean transpose, FloatBuffer mat)`
    `abstract void` | `uniformMatrix4fv(int location, int count, boolean transpose, FloatBuffer mat)`
    `abstract void` | `unmapBuffer(int target)`
    `abstract void` | `useProgram(int program)`
    `abstract void` | `validateProgram(int program)`
    `abstract void` | `vertexAttrib1f(int index, float value)`
    `abstract void` | `vertexAttrib1fv(int index, FloatBuffer values)`
    `abstract void` | `vertexAttrib2f(int index, float value0, float value1)`
    `abstract void` | `vertexAttrib2fv(int index, FloatBuffer values)`
    `abstract void` | `vertexAttrib3f(int index, float value0, float value1, float value2)`
    `abstract void` | `vertexAttrib3fv(int index, FloatBuffer values)`
    `abstract void` | `vertexAttrib4f(int index, float value0, float value1, float value2, float value3)`
    `abstract void` | `vertexAttrib4fv(int index, FloatBuffer values)`
    `abstract void` | `vertexAttribPointer(int index, int size, int type, boolean normalized, int stride, int offset)`
    `abstract void` | `viewport(int x, int y, int w, int h)`

    - ### Methods inherited from class Object

      `equals, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`

- - ### Field Detail

    - #### primaryPGL

          public boolean primaryPGL

      true if this is the GL interface for a primary surface PGraphics

    - #### REQUESTED_DEPTH_BITS

          public static int REQUESTED_DEPTH_BITS

    - #### REQUESTED_STENCIL_BITS

          public static int REQUESTED_STENCIL_BITS

    - #### REQUESTED_ALPHA_BITS

          public static int REQUESTED_ALPHA_BITS

    - #### reqNumSamples

          public int reqNumSamples

    - #### WIKI

          public static final String WIKI

      See Also:
        Constant Field Values

    - #### FRAMEBUFFER_ERROR

          public static final String FRAMEBUFFER_ERROR

      See Also:
        Constant Field Values

    - #### MISSING_FBO_ERROR

          public static final String MISSING_FBO_ERROR

      See Also:
        Constant Field Values

    - #### MISSING_GLSL_ERROR

          public static final String MISSING_GLSL_ERROR

      See Also:
        Constant Field Values

    - #### MISSING_GLFUNC_ERROR

          public static final String MISSING_GLFUNC_ERROR

      See Also:
        Constant Field Values

    - #### UNSUPPORTED_GLPROF_ERROR

          public static final String UNSUPPORTED_GLPROF_ERROR

      See Also:
        Constant Field Values

    - #### TEXUNIT_ERROR

          public static final String TEXUNIT_ERROR

      See Also:
        Constant Field Values

    - #### NONPRIMARY_ERROR

          public static final String NONPRIMARY_ERROR

      See Also:
        Constant Field Values

    - #### presentX

          public float presentX

    - #### presentY

          public float presentY

    - #### FALSE

          public static int FALSE

    - #### TRUE

          public static int TRUE

    - #### INT

          public static int INT

    - #### BYTE

          public static int BYTE

    - #### SHORT

          public static int SHORT

    - #### FLOAT

          public static int FLOAT

    - #### BOOL

          public static int BOOL

    - #### UNSIGNED_INT

          public static int UNSIGNED_INT

    - #### UNSIGNED_BYTE

          public static int UNSIGNED_BYTE

    - #### UNSIGNED_SHORT

          public static int UNSIGNED_SHORT

    - #### RGB

          public static int RGB

    - #### RGBA

          public static int RGBA

    - #### ALPHA

          public static int ALPHA

    - #### LUMINANCE

          public static int LUMINANCE

    - #### LUMINANCE_ALPHA

          public static int LUMINANCE_ALPHA

    - #### UNSIGNED_SHORT_5_6_5

          public static int UNSIGNED_SHORT_5_6_5

    - #### UNSIGNED_SHORT_4_4_4_4

          public static int UNSIGNED_SHORT_4_4_4_4

    - #### UNSIGNED_SHORT_5_5_5_1

          public static int UNSIGNED_SHORT_5_5_5_1

    - #### RGBA4

          public static int RGBA4

    - #### RGB5_A1

          public static int RGB5_A1

    - #### RGB565

          public static int RGB565

    - #### RGB8

          public static int RGB8

    - #### RGBA8

          public static int RGBA8

    - #### ALPHA8

          public static int ALPHA8

    - #### READ_ONLY

          public static int READ_ONLY

    - #### WRITE_ONLY

          public static int WRITE_ONLY

    - #### READ_WRITE

          public static int READ_WRITE

    - #### TESS_WINDING_NONZERO

          public static int TESS_WINDING_NONZERO

    - #### TESS_WINDING_ODD

          public static int TESS_WINDING_ODD

    - #### GENERATE_MIPMAP_HINT

          public static int GENERATE_MIPMAP_HINT

    - #### FASTEST

          public static int FASTEST

    - #### NICEST

          public static int NICEST

    - #### DONT_CARE

          public static int DONT_CARE

    - #### VENDOR

          public static int VENDOR

    - #### RENDERER

          public static int RENDERER

    - #### VERSION

          public static int VERSION

    - #### EXTENSIONS

          public static int EXTENSIONS

    - #### SHADING_LANGUAGE_VERSION

          public static int SHADING_LANGUAGE_VERSION

    - #### MAX_SAMPLES

          public static int MAX_SAMPLES

    - #### SAMPLES

          public static int SAMPLES

    - #### ALIASED_LINE_WIDTH_RANGE

          public static int ALIASED_LINE_WIDTH_RANGE

    - #### ALIASED_POINT_SIZE_RANGE

          public static int ALIASED_POINT_SIZE_RANGE

    - #### DEPTH_BITS

          public static int DEPTH_BITS

    - #### STENCIL_BITS

          public static int STENCIL_BITS

    - #### CCW

          public static int CCW

    - #### CW

          public static int CW

    - #### VIEWPORT

          public static int VIEWPORT

    - #### ARRAY_BUFFER

          public static int ARRAY_BUFFER

    - #### ELEMENT_ARRAY_BUFFER

          public static int ELEMENT_ARRAY_BUFFER

    - #### MAX_VERTEX_ATTRIBS

          public static int MAX_VERTEX_ATTRIBS

    - #### STATIC_DRAW

          public static int STATIC_DRAW

    - #### DYNAMIC_DRAW

          public static int DYNAMIC_DRAW

    - #### STREAM_DRAW

          public static int STREAM_DRAW

    - #### BUFFER_SIZE

          public static int BUFFER_SIZE

    - #### BUFFER_USAGE

          public static int BUFFER_USAGE

    - #### POINTS

          public static int POINTS

    - #### LINE_STRIP

          public static int LINE_STRIP

    - #### LINE_LOOP

          public static int LINE_LOOP

    - #### LINES

          public static int LINES

    - #### TRIANGLE_FAN

          public static int TRIANGLE_FAN

    - #### TRIANGLE_STRIP

          public static int TRIANGLE_STRIP

    - #### TRIANGLES

          public static int TRIANGLES

    - #### CULL_FACE

          public static int CULL_FACE

    - #### FRONT

          public static int FRONT

    - #### BACK

          public static int BACK

    - #### FRONT_AND_BACK

          public static int FRONT_AND_BACK

    - #### POLYGON_OFFSET_FILL

          public static int POLYGON_OFFSET_FILL

    - #### UNPACK_ALIGNMENT

          public static int UNPACK_ALIGNMENT

    - #### PACK_ALIGNMENT

          public static int PACK_ALIGNMENT

    - #### TEXTURE_2D

          public static int TEXTURE_2D

    - #### TEXTURE_RECTANGLE

          public static int TEXTURE_RECTANGLE

    - #### TEXTURE_BINDING_2D

          public static int TEXTURE_BINDING_2D

    - #### TEXTURE_BINDING_RECTANGLE

          public static int TEXTURE_BINDING_RECTANGLE

    - #### MAX_TEXTURE_SIZE

          public static int MAX_TEXTURE_SIZE

    - #### TEXTURE_MAX_ANISOTROPY

          public static int TEXTURE_MAX_ANISOTROPY

    - #### MAX_TEXTURE_MAX_ANISOTROPY

          public static int MAX_TEXTURE_MAX_ANISOTROPY

    - #### MAX_VERTEX_TEXTURE_IMAGE_UNITS

          public static int MAX_VERTEX_TEXTURE_IMAGE_UNITS

    - #### MAX_TEXTURE_IMAGE_UNITS

          public static int MAX_TEXTURE_IMAGE_UNITS

    - #### MAX_COMBINED_TEXTURE_IMAGE_UNITS

          public static int MAX_COMBINED_TEXTURE_IMAGE_UNITS

    - #### NUM_COMPRESSED_TEXTURE_FORMATS

          public static int NUM_COMPRESSED_TEXTURE_FORMATS

    - #### COMPRESSED_TEXTURE_FORMATS

          public static int COMPRESSED_TEXTURE_FORMATS

    - #### NEAREST

          public static int NEAREST

    - #### LINEAR

          public static int LINEAR

    - #### LINEAR_MIPMAP_NEAREST

          public static int LINEAR_MIPMAP_NEAREST

    - #### LINEAR_MIPMAP_LINEAR

          public static int LINEAR_MIPMAP_LINEAR

    - #### CLAMP_TO_EDGE

          public static int CLAMP_TO_EDGE

    - #### REPEAT

          public static int REPEAT

    - #### TEXTURE0

          public static int TEXTURE0

    - #### TEXTURE1

          public static int TEXTURE1

    - #### TEXTURE2

          public static int TEXTURE2

    - #### TEXTURE3

          public static int TEXTURE3

    - #### TEXTURE_MIN_FILTER

          public static int TEXTURE_MIN_FILTER

    - #### TEXTURE_MAG_FILTER

          public static int TEXTURE_MAG_FILTER

    - #### TEXTURE_WRAP_S

          public static int TEXTURE_WRAP_S

    - #### TEXTURE_WRAP_T

          public static int TEXTURE_WRAP_T

    - #### TEXTURE_WRAP_R

          public static int TEXTURE_WRAP_R

    - #### TEXTURE_CUBE_MAP

          public static int TEXTURE_CUBE_MAP

    - #### TEXTURE_CUBE_MAP_POSITIVE_X

          public static int TEXTURE_CUBE_MAP_POSITIVE_X

    - #### TEXTURE_CUBE_MAP_POSITIVE_Y

          public static int TEXTURE_CUBE_MAP_POSITIVE_Y

    - #### TEXTURE_CUBE_MAP_POSITIVE_Z

          public static int TEXTURE_CUBE_MAP_POSITIVE_Z

    - #### TEXTURE_CUBE_MAP_NEGATIVE_X

          public static int TEXTURE_CUBE_MAP_NEGATIVE_X

    - #### TEXTURE_CUBE_MAP_NEGATIVE_Y

          public static int TEXTURE_CUBE_MAP_NEGATIVE_Y

    - #### TEXTURE_CUBE_MAP_NEGATIVE_Z

          public static int TEXTURE_CUBE_MAP_NEGATIVE_Z

    - #### VERTEX_SHADER

          public static int VERTEX_SHADER

    - #### FRAGMENT_SHADER

          public static int FRAGMENT_SHADER

    - #### INFO_LOG_LENGTH

          public static int INFO_LOG_LENGTH

    - #### SHADER_SOURCE_LENGTH

          public static int SHADER_SOURCE_LENGTH

    - #### COMPILE_STATUS

          public static int COMPILE_STATUS

    - #### LINK_STATUS

          public static int LINK_STATUS

    - #### VALIDATE_STATUS

          public static int VALIDATE_STATUS

    - #### SHADER_TYPE

          public static int SHADER_TYPE

    - #### DELETE_STATUS

          public static int DELETE_STATUS

    - #### FLOAT_VEC2

          public static int FLOAT_VEC2

    - #### FLOAT_VEC3

          public static int FLOAT_VEC3

    - #### FLOAT_VEC4

          public static int FLOAT_VEC4

    - #### FLOAT_MAT2

          public static int FLOAT_MAT2

    - #### FLOAT_MAT3

          public static int FLOAT_MAT3

    - #### FLOAT_MAT4

          public static int FLOAT_MAT4

    - #### INT_VEC2

          public static int INT_VEC2

    - #### INT_VEC3

          public static int INT_VEC3

    - #### INT_VEC4

          public static int INT_VEC4

    - #### BOOL_VEC2

          public static int BOOL_VEC2

    - #### BOOL_VEC3

          public static int BOOL_VEC3

    - #### BOOL_VEC4

          public static int BOOL_VEC4

    - #### SAMPLER_2D

          public static int SAMPLER_2D

    - #### SAMPLER_CUBE

          public static int SAMPLER_CUBE

    - #### LOW_FLOAT

          public static int LOW_FLOAT

    - #### MEDIUM_FLOAT

          public static int MEDIUM_FLOAT

    - #### HIGH_FLOAT

          public static int HIGH_FLOAT

    - #### LOW_INT

          public static int LOW_INT

    - #### MEDIUM_INT

          public static int MEDIUM_INT

    - #### HIGH_INT

          public static int HIGH_INT

    - #### CURRENT_VERTEX_ATTRIB

          public static int CURRENT_VERTEX_ATTRIB

    - #### VERTEX_ATTRIB_ARRAY_BUFFER_BINDING

          public static int VERTEX_ATTRIB_ARRAY_BUFFER_BINDING

    - #### VERTEX_ATTRIB_ARRAY_ENABLED

          public static int VERTEX_ATTRIB_ARRAY_ENABLED

    - #### VERTEX_ATTRIB_ARRAY_SIZE

          public static int VERTEX_ATTRIB_ARRAY_SIZE

    - #### VERTEX_ATTRIB_ARRAY_STRIDE

          public static int VERTEX_ATTRIB_ARRAY_STRIDE

    - #### VERTEX_ATTRIB_ARRAY_TYPE

          public static int VERTEX_ATTRIB_ARRAY_TYPE

    - #### VERTEX_ATTRIB_ARRAY_NORMALIZED

          public static int VERTEX_ATTRIB_ARRAY_NORMALIZED

    - #### VERTEX_ATTRIB_ARRAY_POINTER

          public static int VERTEX_ATTRIB_ARRAY_POINTER

    - #### BLEND

          public static int BLEND

    - #### ONE

          public static int ONE

    - #### ZERO

          public static int ZERO

    - #### SRC_ALPHA

          public static int SRC_ALPHA

    - #### DST_ALPHA

          public static int DST_ALPHA

    - #### ONE_MINUS_SRC_ALPHA

          public static int ONE_MINUS_SRC_ALPHA

    - #### ONE_MINUS_DST_COLOR

          public static int ONE_MINUS_DST_COLOR

    - #### ONE_MINUS_SRC_COLOR

          public static int ONE_MINUS_SRC_COLOR

    - #### DST_COLOR

          public static int DST_COLOR

    - #### SRC_COLOR

          public static int SRC_COLOR

    - #### SAMPLE_ALPHA_TO_COVERAGE

          public static int SAMPLE_ALPHA_TO_COVERAGE

    - #### SAMPLE_COVERAGE

          public static int SAMPLE_COVERAGE

    - #### KEEP

          public static int KEEP

    - #### REPLACE

          public static int REPLACE

    - #### INCR

          public static int INCR

    - #### DECR

          public static int DECR

    - #### INVERT

          public static int INVERT

    - #### INCR_WRAP

          public static int INCR_WRAP

    - #### DECR_WRAP

          public static int DECR_WRAP

    - #### NEVER

          public static int NEVER

    - #### ALWAYS

          public static int ALWAYS

    - #### EQUAL

          public static int EQUAL

    - #### LESS

          public static int LESS

    - #### LEQUAL

          public static int LEQUAL

    - #### GREATER

          public static int GREATER

    - #### GEQUAL

          public static int GEQUAL

    - #### NOTEQUAL

          public static int NOTEQUAL

    - #### FUNC_ADD

          public static int FUNC_ADD

    - #### FUNC_MIN

          public static int FUNC_MIN

    - #### FUNC_MAX

          public static int FUNC_MAX

    - #### FUNC_REVERSE_SUBTRACT

          public static int FUNC_REVERSE_SUBTRACT

    - #### FUNC_SUBTRACT

          public static int FUNC_SUBTRACT

    - #### DITHER

          public static int DITHER

    - #### CONSTANT_COLOR

          public static int CONSTANT_COLOR

    - #### CONSTANT_ALPHA

          public static int CONSTANT_ALPHA

    - #### ONE_MINUS_CONSTANT_COLOR

          public static int ONE_MINUS_CONSTANT_COLOR

    - #### ONE_MINUS_CONSTANT_ALPHA

          public static int ONE_MINUS_CONSTANT_ALPHA

    - #### SRC_ALPHA_SATURATE

          public static int SRC_ALPHA_SATURATE

    - #### SCISSOR_TEST

          public static int SCISSOR_TEST

    - #### STENCIL_TEST

          public static int STENCIL_TEST

    - #### DEPTH_TEST

          public static int DEPTH_TEST

    - #### DEPTH_WRITEMASK

          public static int DEPTH_WRITEMASK

    - #### COLOR_BUFFER_BIT

          public static int COLOR_BUFFER_BIT

    - #### DEPTH_BUFFER_BIT

          public static int DEPTH_BUFFER_BIT

    - #### STENCIL_BUFFER_BIT

          public static int STENCIL_BUFFER_BIT

    - #### FRAMEBUFFER

          public static int FRAMEBUFFER

    - #### COLOR_ATTACHMENT0

          public static int COLOR_ATTACHMENT0

    - #### COLOR_ATTACHMENT1

          public static int COLOR_ATTACHMENT1

    - #### COLOR_ATTACHMENT2

          public static int COLOR_ATTACHMENT2

    - #### COLOR_ATTACHMENT3

          public static int COLOR_ATTACHMENT3

    - #### RENDERBUFFER

          public static int RENDERBUFFER

    - #### DEPTH_ATTACHMENT

          public static int DEPTH_ATTACHMENT

    - #### STENCIL_ATTACHMENT

          public static int STENCIL_ATTACHMENT

    - #### READ_FRAMEBUFFER

          public static int READ_FRAMEBUFFER

    - #### DRAW_FRAMEBUFFER

          public static int DRAW_FRAMEBUFFER

    - #### DEPTH24_STENCIL8

          public static int DEPTH24_STENCIL8

    - #### DEPTH_COMPONENT

          public static int DEPTH_COMPONENT

    - #### DEPTH_COMPONENT16

          public static int DEPTH_COMPONENT16

    - #### DEPTH_COMPONENT24

          public static int DEPTH_COMPONENT24

    - #### DEPTH_COMPONENT32

          public static int DEPTH_COMPONENT32

    - #### STENCIL_INDEX

          public static int STENCIL_INDEX

    - #### STENCIL_INDEX1

          public static int STENCIL_INDEX1

    - #### STENCIL_INDEX4

          public static int STENCIL_INDEX4

    - #### STENCIL_INDEX8

          public static int STENCIL_INDEX8

    - #### DEPTH_STENCIL

          public static int DEPTH_STENCIL

    - #### FRAMEBUFFER_COMPLETE

          public static int FRAMEBUFFER_COMPLETE

    - #### FRAMEBUFFER_INCOMPLETE_ATTACHMENT

          public static int FRAMEBUFFER_INCOMPLETE_ATTACHMENT

    - #### FRAMEBUFFER_INCOMPLETE_MISSING_ATTACHMENT

          public static int FRAMEBUFFER_INCOMPLETE_MISSING_ATTACHMENT

    - #### FRAMEBUFFER_INCOMPLETE_DIMENSIONS

          public static int FRAMEBUFFER_INCOMPLETE_DIMENSIONS

    - #### FRAMEBUFFER_INCOMPLETE_FORMATS

          public static int FRAMEBUFFER_INCOMPLETE_FORMATS

    - #### FRAMEBUFFER_INCOMPLETE_DRAW_BUFFER

          public static int FRAMEBUFFER_INCOMPLETE_DRAW_BUFFER

    - #### FRAMEBUFFER_INCOMPLETE_READ_BUFFER

          public static int FRAMEBUFFER_INCOMPLETE_READ_BUFFER

    - #### FRAMEBUFFER_UNSUPPORTED

          public static int FRAMEBUFFER_UNSUPPORTED

    - #### FRAMEBUFFER_ATTACHMENT_OBJECT_TYPE

          public static int FRAMEBUFFER_ATTACHMENT_OBJECT_TYPE

    - #### FRAMEBUFFER_ATTACHMENT_OBJECT_NAME

          public static int FRAMEBUFFER_ATTACHMENT_OBJECT_NAME

    - #### FRAMEBUFFER_ATTACHMENT_TEXTURE_LEVEL

          public static int FRAMEBUFFER_ATTACHMENT_TEXTURE_LEVEL

    - #### FRAMEBUFFER_ATTACHMENT_TEXTURE_CUBE_MAP_FACE

          public static int FRAMEBUFFER_ATTACHMENT_TEXTURE_CUBE_MAP_FACE

    - #### RENDERBUFFER_WIDTH

          public static int RENDERBUFFER_WIDTH

    - #### RENDERBUFFER_HEIGHT

          public static int RENDERBUFFER_HEIGHT

    - #### RENDERBUFFER_RED_SIZE

          public static int RENDERBUFFER_RED_SIZE

    - #### RENDERBUFFER_GREEN_SIZE

          public static int RENDERBUFFER_GREEN_SIZE

    - #### RENDERBUFFER_BLUE_SIZE

          public static int RENDERBUFFER_BLUE_SIZE

    - #### RENDERBUFFER_ALPHA_SIZE

          public static int RENDERBUFFER_ALPHA_SIZE

    - #### RENDERBUFFER_DEPTH_SIZE

          public static int RENDERBUFFER_DEPTH_SIZE

    - #### RENDERBUFFER_STENCIL_SIZE

          public static int RENDERBUFFER_STENCIL_SIZE

    - #### RENDERBUFFER_INTERNAL_FORMAT

          public static int RENDERBUFFER_INTERNAL_FORMAT

    - #### MULTISAMPLE

          public static int MULTISAMPLE

    - #### LINE_SMOOTH

          public static int LINE_SMOOTH

    - #### POLYGON_SMOOTH

          public static int POLYGON_SMOOTH

  - ### Constructor Detail

    - #### PGL

          public PGL()

    - #### PGL

          public PGL(PGraphicsOpenGL pg)

  - ### Method Detail

    - #### dispose

          public void dispose()

    - #### setPrimary

          public void setPrimary(boolean primary)

    - #### smoothToSamples

          public static int smoothToSamples(int smooth)

    - #### getNative

          public abstract Object getNative()

    - #### requestFBOLayer

          @Deprecated
          public void requestFBOLayer()

      Deprecated.

    - #### enableFBOLayer

          public void enableFBOLayer()

    - #### disableFBOLayer

          public void disableFBOLayer()

    - #### resetFBOLayer

          public void resetFBOLayer()

    - #### initPresentMode

          public void initPresentMode(float x,
                                      float y)

    - #### presentMode

          public boolean presentMode()

    - #### presentX

          public float presentX()

    - #### presentY

          public float presentY()

    - #### insideCloseButton

          public boolean insideCloseButton(float x,
                                           float y)

    - #### threadIsCurrent

          public boolean threadIsCurrent()

    - #### setThread

          public void setThread(Thread thread)

    - #### drawTexture

          public void drawTexture(int target,
                                  int id,
                                  int width,
                                  int height,
                                  int X0,
                                  int Y0,
                                  int X1,
                                  int Y1)

      Not an approved function, this will change or be removed in the future.

    - #### drawTexture

          public void drawTexture(int target,
                                  int id,
                                  int texW,
                                  int texH,
                                  int viewX,
                                  int viewY,
                                  int viewW,
                                  int viewH,
                                  int texX0,
                                  int texY0,
                                  int texX1,
                                  int texY1,
                                  int scrX0,
                                  int scrY0,
                                  int scrX1,
                                  int scrY1)

      Not an approved function, this will change or be removed in the future.

    - #### drawTexture

          public void drawTexture(int target,
                                  int id,
                                  int texW,
                                  int texH,
                                  int viewX,
                                  int viewY,
                                  int viewW,
                                  int viewH,
                                  int viewF,
                                  int texX0,
                                  int texY0,
                                  int texX1,
                                  int texY1,
                                  int scrX0,
                                  int scrY0,
                                  int scrX1,
                                  int scrY1)

    - #### flush

          public abstract void flush()

    - #### finish

          public abstract void finish()

    - #### hint

          public abstract void hint(int target,
                                    int hint)

    - #### enable

          public abstract void enable(int value)

    - #### disable

          public abstract void disable(int value)

    - #### getBooleanv

          public abstract void getBooleanv(int value,
                                           IntBuffer data)

    - #### getIntegerv

          public abstract void getIntegerv(int value,
                                           IntBuffer data)

    - #### getFloatv

          public abstract void getFloatv(int value,
                                         FloatBuffer data)

    - #### isEnabled

          public abstract boolean isEnabled(int value)

    - #### getString

          public abstract String getString(int name)

    - #### getError

          public abstract int getError()

    - #### errorString

          public abstract String errorString(int err)

    - #### genBuffers

          public abstract void genBuffers(int n,
                                          IntBuffer buffers)

    - #### deleteBuffers

          public abstract void deleteBuffers(int n,
                                             IntBuffer buffers)

    - #### bindBuffer

          public abstract void bindBuffer(int target,
                                          int buffer)

    - #### bufferData

          public abstract void bufferData(int target,
                                          int size,
                                          Buffer data,
                                          int usage)

    - #### bufferSubData

          public abstract void bufferSubData(int target,
                                             int offset,
                                             int size,
                                             Buffer data)

    - #### isBuffer

          public abstract void isBuffer(int buffer)

    - #### getBufferParameteriv

          public abstract void getBufferParameteriv(int target,
                                                    int value,
                                                    IntBuffer data)

    - #### mapBuffer

          public abstract ByteBuffer mapBuffer(int target,
                                               int access)

    - #### mapBufferRange

          public abstract ByteBuffer mapBufferRange(int target,
                                                    int offset,
                                                    int length,
                                                    int access)

    - #### unmapBuffer

          public abstract void unmapBuffer(int target)

    - #### depthRangef

          public abstract void depthRangef(float n,
                                           float f)

    - #### viewport

          public abstract void viewport(int x,
                                        int y,
                                        int w,
                                        int h)

    - #### readPixels

          public void readPixels(int x,
                                 int y,
                                 int width,
                                 int height,
                                 int format,
                                 int type,
                                 Buffer buffer)

    - #### vertexAttrib1f

          public abstract void vertexAttrib1f(int index,
                                              float value)

    - #### vertexAttrib2f

          public abstract void vertexAttrib2f(int index,
                                              float value0,
                                              float value1)

    - #### vertexAttrib3f

          public abstract void vertexAttrib3f(int index,
                                              float value0,
                                              float value1,
                                              float value2)

    - #### vertexAttrib4f

          public abstract void vertexAttrib4f(int index,
                                              float value0,
                                              float value1,
                                              float value2,
                                              float value3)

    - #### vertexAttrib1fv

          public abstract void vertexAttrib1fv(int index,
                                               FloatBuffer values)

    - #### vertexAttrib2fv

          public abstract void vertexAttrib2fv(int index,
                                               FloatBuffer values)

    - #### vertexAttrib3fv

          public abstract void vertexAttrib3fv(int index,
                                               FloatBuffer values)

    - #### vertexAttrib4fv

          public abstract void vertexAttrib4fv(int index,
                                               FloatBuffer values)

    - #### vertexAttribPointer

          public abstract void vertexAttribPointer(int index,
                                                   int size,
                                                   int type,
                                                   boolean normalized,
                                                   int stride,
                                                   int offset)

    - #### enableVertexAttribArray

          public abstract void enableVertexAttribArray(int index)

    - #### disableVertexAttribArray

          public abstract void disableVertexAttribArray(int index)

    - #### drawArrays

          public void drawArrays(int mode,
                                 int first,
                                 int count)

    - #### drawArraysImpl

          public abstract void drawArraysImpl(int mode,
                                              int first,
                                              int count)

    - #### drawElements

          public void drawElements(int mode,
                                   int count,
                                   int type,
                                   int offset)

    - #### drawElementsImpl

          public abstract void drawElementsImpl(int mode,
                                                int count,
                                                int type,
                                                int offset)

    - #### lineWidth

          public abstract void lineWidth(float width)

    - #### frontFace

          public abstract void frontFace(int dir)

    - #### cullFace

          public abstract void cullFace(int mode)

    - #### polygonOffset

          public abstract void polygonOffset(float factor,
                                             float units)

    - #### pixelStorei

          public abstract void pixelStorei(int pname,
                                           int param)

    - #### texImage2D

          public abstract void texImage2D(int target,
                                          int level,
                                          int internalFormat,
                                          int width,
                                          int height,
                                          int border,
                                          int format,
                                          int type,
                                          Buffer data)

    - #### copyTexImage2D

          public abstract void copyTexImage2D(int target,
                                              int level,
                                              int internalFormat,
                                              int x,
                                              int y,
                                              int width,
                                              int height,
                                              int border)

    - #### texSubImage2D

          public abstract void texSubImage2D(int target,
                                             int level,
                                             int xOffset,
                                             int yOffset,
                                             int width,
                                             int height,
                                             int format,
                                             int type,
                                             Buffer data)

    - #### copyTexSubImage2D

          public abstract void copyTexSubImage2D(int target,
                                                 int level,
                                                 int xOffset,
                                                 int yOffset,
                                                 int x,
                                                 int y,
                                                 int width,
                                                 int height)

    - #### compressedTexImage2D

          public abstract void compressedTexImage2D(int target,
                                                    int level,
                                                    int internalFormat,
                                                    int width,
                                                    int height,
                                                    int border,
                                                    int imageSize,
                                                    Buffer data)

    - #### compressedTexSubImage2D

          public abstract void compressedTexSubImage2D(int target,
                                                       int level,
                                                       int xOffset,
                                                       int yOffset,
                                                       int width,
                                                       int height,
                                                       int format,
                                                       int imageSize,
                                                       Buffer data)

    - #### texParameteri

          public abstract void texParameteri(int target,
                                             int pname,
                                             int param)

    - #### texParameterf

          public abstract void texParameterf(int target,
                                             int pname,
                                             float param)

    - #### texParameteriv

          public abstract void texParameteriv(int target,
                                              int pname,
                                              IntBuffer params)

    - #### texParameterfv

          public abstract void texParameterfv(int target,
                                              int pname,
                                              FloatBuffer params)

    - #### generateMipmap

          public abstract void generateMipmap(int target)

    - #### genTextures

          public abstract void genTextures(int n,
                                           IntBuffer textures)

    - #### deleteTextures

          public abstract void deleteTextures(int n,
                                              IntBuffer textures)

    - #### getTexParameteriv

          public abstract void getTexParameteriv(int target,
                                                 int pname,
                                                 IntBuffer params)

    - #### getTexParameterfv

          public abstract void getTexParameterfv(int target,
                                                 int pname,
                                                 FloatBuffer params)

    - #### isTexture

          public abstract boolean isTexture(int texture)

    - #### activeTexture

          public void activeTexture(int texture)

    - #### bindTexture

          public void bindTexture(int target,
                                  int texture)

    - #### createShader

          public abstract int createShader(int type)

    - #### shaderSource

          public abstract void shaderSource(int shader,
                                            String source)

    - #### compileShader

          public abstract void compileShader(int shader)

    - #### releaseShaderCompiler

          public abstract void releaseShaderCompiler()

    - #### deleteShader

          public abstract void deleteShader(int shader)

    - #### shaderBinary

          public abstract void shaderBinary(int count,
                                            IntBuffer shaders,
                                            int binaryFormat,
                                            Buffer binary,
                                            int length)

    - #### createProgram

          public abstract int createProgram()

    - #### attachShader

          public abstract void attachShader(int program,
                                            int shader)

    - #### detachShader

          public abstract void detachShader(int program,
                                            int shader)

    - #### linkProgram

          public abstract void linkProgram(int program)

    - #### useProgram

          public abstract void useProgram(int program)

    - #### deleteProgram

          public abstract void deleteProgram(int program)

    - #### getActiveAttrib

          public abstract String getActiveAttrib(int program,
                                                 int index,
                                                 IntBuffer size,
                                                 IntBuffer type)

    - #### getAttribLocation

          public abstract int getAttribLocation(int program,
                                                String name)

    - #### bindAttribLocation

          public abstract void bindAttribLocation(int program,
                                                  int index,
                                                  String name)

    - #### getUniformLocation

          public abstract int getUniformLocation(int program,
                                                 String name)

    - #### getActiveUniform

          public abstract String getActiveUniform(int program,
                                                  int index,
                                                  IntBuffer size,
                                                  IntBuffer type)

    - #### uniform1i

          public abstract void uniform1i(int location,
                                         int value)

    - #### uniform2i

          public abstract void uniform2i(int location,
                                         int value0,
                                         int value1)

    - #### uniform3i

          public abstract void uniform3i(int location,
                                         int value0,
                                         int value1,
                                         int value2)

    - #### uniform4i

          public abstract void uniform4i(int location,
                                         int value0,
                                         int value1,
                                         int value2,
                                         int value3)

    - #### uniform1f

          public abstract void uniform1f(int location,
                                         float value)

    - #### uniform2f

          public abstract void uniform2f(int location,
                                         float value0,
                                         float value1)

    - #### uniform3f

          public abstract void uniform3f(int location,
                                         float value0,
                                         float value1,
                                         float value2)

    - #### uniform4f

          public abstract void uniform4f(int location,
                                         float value0,
                                         float value1,
                                         float value2,
                                         float value3)

    - #### uniform1iv

          public abstract void uniform1iv(int location,
                                          int count,
                                          IntBuffer v)

    - #### uniform2iv

          public abstract void uniform2iv(int location,
                                          int count,
                                          IntBuffer v)

    - #### uniform3iv

          public abstract void uniform3iv(int location,
                                          int count,
                                          IntBuffer v)

    - #### uniform4iv

          public abstract void uniform4iv(int location,
                                          int count,
                                          IntBuffer v)

    - #### uniform1fv

          public abstract void uniform1fv(int location,
                                          int count,
                                          FloatBuffer v)

    - #### uniform2fv

          public abstract void uniform2fv(int location,
                                          int count,
                                          FloatBuffer v)

    - #### uniform3fv

          public abstract void uniform3fv(int location,
                                          int count,
                                          FloatBuffer v)

    - #### uniform4fv

          public abstract void uniform4fv(int location,
                                          int count,
                                          FloatBuffer v)

    - #### uniformMatrix2fv

          public abstract void uniformMatrix2fv(int location,
                                                int count,
                                                boolean transpose,
                                                FloatBuffer mat)

    - #### uniformMatrix3fv

          public abstract void uniformMatrix3fv(int location,
                                                int count,
                                                boolean transpose,
                                                FloatBuffer mat)

    - #### uniformMatrix4fv

          public abstract void uniformMatrix4fv(int location,
                                                int count,
                                                boolean transpose,
                                                FloatBuffer mat)

    - #### validateProgram

          public abstract void validateProgram(int program)

    - #### isShader

          public abstract boolean isShader(int shader)

    - #### getShaderiv

          public abstract void getShaderiv(int shader,
                                           int pname,
                                           IntBuffer params)

    - #### getAttachedShaders

          public abstract void getAttachedShaders(int program,
                                                  int maxCount,
                                                  IntBuffer count,
                                                  IntBuffer shaders)

    - #### getShaderInfoLog

          public abstract String getShaderInfoLog(int shader)

    - #### getShaderSource

          public abstract String getShaderSource(int shader)

    - #### getShaderPrecisionFormat

          public abstract void getShaderPrecisionFormat(int shaderType,
                                                        int precisionType,
                                                        IntBuffer range,
                                                        IntBuffer precision)

    - #### getVertexAttribfv

          public abstract void getVertexAttribfv(int index,
                                                 int pname,
                                                 FloatBuffer params)

    - #### getVertexAttribiv

          public abstract void getVertexAttribiv(int index,
                                                 int pname,
                                                 IntBuffer params)

    - #### getVertexAttribPointerv

          public abstract void getVertexAttribPointerv(int index,
                                                       int pname,
                                                       ByteBuffer data)

    - #### getUniformfv

          public abstract void getUniformfv(int program,
                                            int location,
                                            FloatBuffer params)

    - #### getUniformiv

          public abstract void getUniformiv(int program,
                                            int location,
                                            IntBuffer params)

    - #### isProgram

          public abstract boolean isProgram(int program)

    - #### getProgramiv

          public abstract void getProgramiv(int program,
                                            int pname,
                                            IntBuffer params)

    - #### getProgramInfoLog

          public abstract String getProgramInfoLog(int program)

    - #### scissor

          public abstract void scissor(int x,
                                       int y,
                                       int w,
                                       int h)

    - #### sampleCoverage

          public abstract void sampleCoverage(float value,
                                              boolean invert)

    - #### stencilFunc

          public abstract void stencilFunc(int func,
                                           int ref,
                                           int mask)

    - #### stencilFuncSeparate

          public abstract void stencilFuncSeparate(int face,
                                                   int func,
                                                   int ref,
                                                   int mask)

    - #### stencilOp

          public abstract void stencilOp(int sfail,
                                         int dpfail,
                                         int dppass)

    - #### stencilOpSeparate

          public abstract void stencilOpSeparate(int face,
                                                 int sfail,
                                                 int dpfail,
                                                 int dppass)

    - #### depthFunc

          public abstract void depthFunc(int func)

    - #### blendEquation

          public abstract void blendEquation(int mode)

    - #### blendEquationSeparate

          public abstract void blendEquationSeparate(int modeRGB,
                                                     int modeAlpha)

    - #### blendFunc

          public abstract void blendFunc(int src,
                                         int dst)

    - #### blendFuncSeparate

          public abstract void blendFuncSeparate(int srcRGB,
                                                 int dstRGB,
                                                 int srcAlpha,
                                                 int dstAlpha)

    - #### blendColor

          public abstract void blendColor(float red,
                                          float green,
                                          float blue,
                                          float alpha)

    - #### colorMask

          public abstract void colorMask(boolean r,
                                         boolean g,
                                         boolean b,
                                         boolean a)

    - #### depthMask

          public abstract void depthMask(boolean mask)

    - #### stencilMask

          public abstract void stencilMask(int mask)

    - #### stencilMaskSeparate

          public abstract void stencilMaskSeparate(int face,
                                                   int mask)

    - #### clearColor

          public abstract void clearColor(float r,
                                          float g,
                                          float b,
                                          float a)

    - #### clearDepth

          public abstract void clearDepth(float d)

    - #### clearStencil

          public abstract void clearStencil(int s)

    - #### clear

          public abstract void clear(int buf)

    - #### bindFramebuffer

          public void bindFramebuffer(int target,
                                      int framebuffer)

    - #### deleteFramebuffers

          public abstract void deleteFramebuffers(int n,
                                                  IntBuffer framebuffers)

    - #### genFramebuffers

          public abstract void genFramebuffers(int n,
                                               IntBuffer framebuffers)

    - #### bindRenderbuffer

          public abstract void bindRenderbuffer(int target,
                                                int renderbuffer)

    - #### deleteRenderbuffers

          public abstract void deleteRenderbuffers(int n,
                                                   IntBuffer renderbuffers)

    - #### genRenderbuffers

          public abstract void genRenderbuffers(int n,
                                                IntBuffer renderbuffers)

    - #### renderbufferStorage

          public abstract void renderbufferStorage(int target,
                                                   int internalFormat,
                                                   int width,
                                                   int height)

    - #### framebufferRenderbuffer

          public abstract void framebufferRenderbuffer(int target,
                                                       int attachment,
                                                       int rendbuferfTarget,
                                                       int renderbuffer)

    - #### framebufferTexture2D

          public abstract void framebufferTexture2D(int target,
                                                    int attachment,
                                                    int texTarget,
                                                    int texture,
                                                    int level)

    - #### checkFramebufferStatus

          public abstract int checkFramebufferStatus(int target)

    - #### isFramebuffer

          public abstract boolean isFramebuffer(int framebuffer)

    - #### getFramebufferAttachmentParameteriv

          public abstract void getFramebufferAttachmentParameteriv(int target,
                                                                   int attachment,
                                                                   int pname,
                                                                   IntBuffer params)

    - #### isRenderbuffer

          public abstract boolean isRenderbuffer(int renderbuffer)

    - #### getRenderbufferParameteriv

          public abstract void getRenderbufferParameteriv(int target,
                                                          int pname,
                                                          IntBuffer params)

    - #### blitFramebuffer

          public abstract void blitFramebuffer(int srcX0,
                                               int srcY0,
                                               int srcX1,
                                               int srcY1,
                                               int dstX0,
                                               int dstY0,
                                               int dstX1,
                                               int dstY1,
                                               int mask,
                                               int filter)

    - #### renderbufferStorageMultisample

          public abstract void renderbufferStorageMultisample(int target,
                                                              int samples,
                                                              int format,
                                                              int width,
                                                              int height)

    - #### readBuffer

          public abstract void readBuffer(int buf)

    - #### drawBuffer

          public abstract void drawBuffer(int buf)